package io.tswf.transmutations.view.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.Type
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class CantReachFieldException extends RuntimeException {
    String fieldName
    Type fieldType
    ClassNode targetClass

    CantReachFieldException(String fieldName, Type fieldType, ClassNode targetClass) {
        super("Field with name '${fieldName}' and type ${fieldType.className} is not presented in ${targetClass}")
        this.fieldName = fieldName
        this.fieldType = fieldType
        this.targetClass = targetClass
    }
}
