package io.tswf.transmutations.view.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class InvalidViewClassException extends RuntimeException {
    ClassNode viewClass

    InvalidViewClassException(String invalidCause, ClassNode viewClass) {
        super("The view class ${viewClass.javaName} is invalid because ${invalidCause}")
        this.viewClass = viewClass
    }
}
