package io.tswf.transmutations.view.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.view.meta.ViewMetadata
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class InvalidViewTargetException extends RuntimeException {
    ViewMetadata viewMeta
    ClassNode target

    InvalidViewTargetException(ViewMetadata viewMeta, ClassNode target) {
        super("There is no view methods found for ${target.javaName} in view ${viewMeta.viewClass.javaName}! This view has targets: ${viewMeta.targets.map { it.className }}")
        this.viewMeta = viewMeta
        this.target = target
    }
}
