package io.tswf.transmutations.view.meta

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.conflict.ConflictingMethodResolveStrategy
import io.tswf.transmutations.common.conflict.IConflictingMethodResolveStrategyProvider
import io.tswf.transmutations.view.generation.IViewMethodMapper
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.Type
import org.objectweb.asm.tree.MethodNode

@CheckedMapConstructor
@CompileStatic
class ViewMethodMetadata implements IConflictingMethodResolveStrategyProvider {
    public static ConflictingMethodResolveStrategy DEFAULT_CONFLICT_RESOLVE_STRATEGY = ConflictingMethodResolveStrategy.THROW

    // Если у каждой метадаты метода будет только один тип цели, то это позволит делать ремаппинг в read-time
    Type targetType
    ViewMetadata view
    MethodNode viewMethod
    IViewMethodMapper mapper
    ConflictingMethodResolveStrategy conflictStrategy = DEFAULT_CONFLICT_RESOLVE_STRATEGY
}
