package io.tswf.transmutations.view.util

import groovy.transform.CompileStatic
import io.tswf.transmutations.view.exception.InvalidViewMethodException
import io.tswf.transmutations.view.meta.ViewMethodMetadata
import org.objectweb.asm.Type
import org.objectweb.asm.commons.Method

@CompileStatic
class ReturnTypeHelper {

    static boolean validateMethodReturnTypesAndCheckPop(Method methodToCall, ViewMethodMetadata viewMethodMeta) {
        def viewMethodReturnType = viewMethodMeta.viewMethod.returnType
        def methodToInvokerReturnType = Type.getReturnType(methodToCall.descriptor)
        // Сравниваем возвращаемые типы
        if (viewMethodReturnType != methodToInvokerReturnType) {
            if (viewMethodReturnType == Type.VOID_TYPE) {
                return true
            } else if (viewMethodReturnType.descriptor == Object.asmDescriptor && !methodToInvokerReturnType.isPrimitive()) {
                // В таком случае тип возвращаемого значения можно прикастовать
            } else {
                throw new InvalidViewMethodException("because it return type does not matches with target return type. Expected ${methodToInvokerReturnType.className}, but was ${viewMethodReturnType.className}", viewMethodMeta)
            }
        }

        return false
    }
}
